unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    PnlBack: TPanel;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    Label2: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Timer1: TTimer;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    PaintBox3: TPaintBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    //FResNameList: TStringList;
    //FRotateNameList: TStringList;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    Info, mt19937ar;

{$R *.dfm}

const
    RESIMG_NAME: array[0..59] of String =
    (
    'IMG_F2', 'IMG_Fd2', 'IMG_F', 'IMG_Fd', 'IMG_Fw2', 'IMG_Fdw2', 'IMG_Fw', 'IMG_Fdw',
    'IMG_B2', 'IMG_Bd2', 'IMG_B', 'IMG_Bd', 'IMG_Bw2', 'IMG_Bdw2', 'IMG_Bw', 'IMG_Bdw',

    'IMG_R2', 'IMG_R2d', 'IMG_R', 'IMG_Rd', 'IMG_Rw2', 'IMG_Rdw2', 'IMG_Rw', 'IMG_Rdw',
    'IMG_L2', 'IMG_Ld2', 'IMG_L', 'IMG_Ld', 'IMG_Lw2', 'IMG_Ldw2', 'IMG_Lw', 'IMG_Ldw',

    'IMG_U2', 'IMG_Ud2', 'IMG_U', 'IMG_Ud', 'IMG_Uw2', 'IMG_Udw2', 'IMG_Uw', 'IMG_Udw',
    'IMG_D2', 'IMG_Dd2', 'IMG_D', 'IMG_Dd', 'IMG_Dw2', 'IMG_Ddw2', 'IMG_Dw', 'IMG_Ddw',

    'IMG_E2', 'IMG_Ed2', 'IMG_E', 'IMG_Ed',
    'IMG_M2', 'IMG_Md2', 'IMG_M', 'IMG_Md',
    'IMG_S2', 'IMG_Sd2', 'IMG_S', 'IMG_Sd'
    );

    ROTATE_NAME: array[0..59] of String =
    (
    'F2  ', 'F''2 ', 'F   ', 'F''  ', 'Fw2 ', 'F''w2', 'Fw  ', 'F''w ',
    'B2  ', 'B''2 ', 'B   ', 'B''  ', 'Bw2 ', 'B''w2', 'Bw  ', 'B''w ',

    'R2  ', 'R2'' ', 'R   ', 'R''  ', 'Rw2 ', 'R''w2', 'Rw  ', 'R''w ',
    'L2  ', 'L''2 ', 'L   ', 'L''  ', 'Lw2 ', 'L''w2', 'Lw  ', 'L''w ',

    'U2  ', 'U''2 ', 'U   ', 'U''  ', 'Uw2 ', 'U''w2', 'Uw  ', 'U''w ',
    'D2  ', 'D''2 ', 'D   ', 'D''  ', 'Dw2 ', 'D''w2', 'Dw  ', 'D''w ',

    'E2  ', 'E''2 ', 'E   ', 'E''  ',
    'M2  ', 'M''2 ', 'M   ', 'M''  ',
    'S2  ', 'S''2 ', 'S   ', 'S''  '
    );
(*
type
    TRotateCondition = (rcDenySliceMove, rcDenyDoubleMove, rcDeny180Move);
    TRotateConditions = set of TRotateCondition;

//-----------------------------------------------------------------------------
procedure BuildScramble(const ACount: Integer;
                        const ACondition: TRotateConditions;
                        AResNameList, ARotateNameList: TStrings);
var
    LRandom: Int64;
    LValue: Integer;
    LRotateName: String;
begin
    AResNameList.Clear();
    ARotateNameList.Clear();
    while (AResNameList.Count < ACount) do
    begin
        LRandom := GenRandInt32() * GetTickCount();
        LValue := LRandom mod 60;
        LRotateName := ROTATE_NAME[LValue];

        //  XCX[u~
        if (rcDenySliceMove in ACondition) then
        begin
            if (Pos('E', LRotateName) > 0) then Continue;
            if (Pos('M', LRotateName) > 0) then Continue;
            if (Pos('S', LRotateName) > 0) then Continue;
        end;

        //  2w[u~
        if (rcDenyDoubleMove in ACondition) then
        begin
            if (Pos('w', LRotateName) > 0) then Continue;
        end;

        //  180x[u~
        if (rcDeny180Move in ACondition) then
        begin
            if (Pos('''', LRotateName) > 0) then Continue;
        end;

        //  ǉ
        ARotateNameList.Add(LRotateName);
        AResNameList.Add(RESIMG_NAME[LValue]);
    end;
end;
*)
//-----------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
//    FResNameList := TStringList.Create();
//    FRotateNameList := TStringList.Create();

    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];
    PaintBox2.ControlStyle := PaintBox2.ControlStyle + [csOpaque];
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
//    FResNameList.Free();
//    FRotateNameList.Free();
end;

//-----------------------------------------------------------------------------
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
//    Timer1.Interval := 2000;
    Timer1.Enabled := True;
    Timer1.Tag := 0;
    PaintBox3.Repaint();
end;

//-----------------------------------------------------------------------------
procedure TForm1.BitBtn4Click(Sender: TObject);
var
    LNewInterval: Integer;
begin
    LNewInterval := Timer1.Interval + 50;
    if (LNewInterval <= 5000) then Timer1.Interval := LNewInterval;
    PaintBox3.Repaint();
end;

//-----------------------------------------------------------------------------
procedure TForm1.BitBtn5Click(Sender: TObject);
var
    LNewInterval: Integer;
begin
    LNewInterval := Timer1.Interval - 50;
    if (500 <= LNewInterval) then Timer1.Interval := LNewInterval;
    PaintBox3.Repaint();
end;

//-----------------------------------------------------------------------------
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
    Timer1.Enabled := False;
//    PaintBox1.Tag := -1;
//    PaintBox2.Tag := -1;
    PaintBox1.Repaint();
    PaintBox2.Repaint();
end;

//-----------------------------------------------------------------------------
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
var
    LNewTag: Int64;
begin
    Timer1.Tag := Timer1.Tag + 1;
    LNewTag := GenRandInt32() * GetTickCount();
    PaintBox1.Tag := LNewTag mod 60;
    PaintBox2.Tag := LNewTag mod 60;
    PaintBox1.Repaint();
    PaintBox2.Repaint();
end;

//-----------------------------------------------------------------------------
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    LBuffer: TBitmap;
    LResBuf: TBitmap;
    LPaintBox: TPaintBox;
    LTag: Integer;
begin
    LPaintBox := TPaintBox(Sender);
    LTag := LPaintBox.Tag;

    LBuffer := nil;
    LResBuf := nil;
    try
        LBuffer := TBitmap.Create();
        LBuffer.Width := LPaintBox.Width;
        LBuffer.Height := LPaintBox.Height;

        //  hԂ
        LBuffer.Canvas.Brush.Color := Self.Color;
        LBuffer.Canvas.FillRect(LPaintBox.ClientRect);

        if (LTag >= 0) then
        begin

            //  摜擾
            LResBuf := TBitmap.Create();
            LResBuf.LoadFromResourceName(HInstance, RESIMG_NAME[LTag mod 60]);

            //  摜`
            LBuffer.Canvas.Draw(
                        (LBuffer.Width - LResBuf.Width) shr 1,
                        (LBuffer.Height - LResBuf.Height) shr 1,
                        LResBuf);
        end;

        BitBlt(LPaintBox.Canvas.Handle, 0, 0, LPaintBox.Width, LPaintBox.Height,
            LBuffer.Canvas.Handle, 0, 0, SRCCOPY);
    finally
        LBuffer.Free();
        LResBuf.Free();
    end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.PaintBox2Paint(Sender: TObject);
var
    LBuffer: TBitmap;
    LPaintBox: TPaintBox;
    LTag: Integer;
    LBkMode: Integer;
    LRect: TRect;
    LText: String;
begin
    LPaintBox := TPaintBox(Sender);
    LTag := LPaintBox.Tag;
    LRect := LPaintBox.ClientRect;

    if (Sender = PaintBox2) then
    begin
        LText := Format('%3d. %s', [Timer1.Tag, ROTATE_NAME[LTag mod 60]]);
    end
    else
    begin
        LText := Format('1 scramble per %d milliseconds', [Timer1.Interval]);
    end;

    LBuffer := nil;
    try
        LBuffer := TBitmap.Create();
        LBuffer.Width := LPaintBox.Width;
        LBuffer.Height := LPaintBox.Height;

        //  hԂ
        LBuffer.Canvas.Brush.Color := Self.Color;
        LBuffer.Canvas.FillRect(LPaintBox.ClientRect);

        if (LTag >= 0) then
        begin

            //  `
            LBuffer.Canvas.Font.Assign(LPaintBox.Canvas.Font);
            LBkMode := SetBkMode(LBuffer.Canvas.Handle, TRANSPARENT);
            DrawText(LBuffer.Canvas.Handle,
                        PChar(LText),
                        -1,
                        LRect,
                        DT_SINGLELINE or DT_CENTER or DT_VCENTER);
            SetBkMode(LBuffer.Canvas.Handle, LBkMode);
        end;

        BitBlt(LPaintBox.Canvas.Handle, 0, 0, LPaintBox.Width, LPaintBox.Height,
            LBuffer.Canvas.Handle, 0, 0, SRCCOPY);
    finally
        LBuffer.Free();
    end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Label2Click(Sender: TObject);
begin
    SimpleShellExecute(TLabel(Sender).Hint);
end;

end.
